namespace LeCompteEstBon
{
 using System;
 public class LeCompteEstBon
 {
  static int Niveau=0;
  static int N=6;     // Nombre de nombres
  struct OPERATION
  {
   public int Total;
   public int N1, N2;
   public char op;
   public bool interm;
  } 
  static OPERATION[] Ops = new OPERATION[10];

//
//--------------------------------------------------------------------------
//
  static void RetenirOpration(int Niv, int N1, char op, int N2, int TOTAL, bool interm)
  {
   Ops[Niv].N1 = N1; Ops[Niv].N2 = N2; Ops[Niv].Total = TOTAL;
   Ops[Niv].op = op;
   Ops[Niv].interm = interm;
   if (Niveau < Niv) Niveau = Niv;
  }

//
//--------------------------------------------------------------------------
//
  static void AfficherRsultat()
  {
   // Afficher d'abord les calculs intermdiaires
   for (int i=0; i<Niveau; i++)
    if (Ops[i].interm) 
      Console.WriteLine(Ops[i].N1 + " " + Ops[i].op + " " + Ops[i].N2 + " = " + Ops[i].Total);

   for (int i=Niveau; i>=0; i--) 
    if (Ops[i].interm == false) 
      Console.WriteLine(Ops[i].N1 + " " + Ops[i].op + " " + Ops[i].N2 + " = " + Ops[i].Total);
  }

//
//--------------------------------------------------------------------------
//
  public static void Main(string[] args)
  {
   int[] Nombres = new int[N];
   int Total;
   
   // saisir les N nombres
   string s;
   for (int i=0; i<N; ++i)
   {
    Console.Write("N[" + i + "] ? "); 
    s = Console.ReadLine(); Nombres[i] = Int32.Parse(s);
   }

   // saisie du total
   Console.Write("Total ? "); 
   s = Console.ReadLine(); Total = Int32.Parse(s);
   Console.WriteLine();

   // rechercher LA solution
   bool trouv = lcb(Nombres, Total, 0);
   if (trouv == true) 
   {
    Console.WriteLine("Le compte est bon !");
    AfficherRsultat();
    Console.Read();
    return;
   }

   // LA solution n'ayant pas t trouve, rechercher la solution la plus proche 
   int inc=0;
   do
   {
    trouv = lcb(Nombres, Total+inc, 0);
    if (trouv == false) trouv = lcb(Nombres, Total-inc, 0);
    inc++;
   } while (trouv == false);
   Console.WriteLine("Meilleure solution : ");
   AfficherRsultat();
   Console.Read();
  }



static bool EssaiOpration(int TOTAL, int NB, int[] tr, int Niv)
{
 bool trouv;

 if (TOTAL <= 0) return false; 

 // Peut-on raliser TOTAL = NB + ? (? dsignant une combinaison des nombres restants)
 if (TOTAL > NB)
 {
  trouv = lcb(tr, TOTAL-NB, Niv+1);
  if (trouv)
  {
   RetenirOpration(Niv, NB, '+', (TOTAL-NB), TOTAL, false);
   return true;
  }
 }
 
 // Peut-on raliser TOTAL = NB - ?
 if (TOTAL < NB)
 {
  trouv = lcb(tr, NB-TOTAL, Niv+1);
  if (trouv)
  {
   RetenirOpration(Niv, NB, '-', (NB-TOTAL), TOTAL, false);
   return true;
  }
 }

 // Peut-on raliser TOTAL = ? - NB
 trouv = lcb(tr, NB+TOTAL, Niv+1);
 if (trouv)
 {
  RetenirOpration(Niv, (TOTAL+NB), '-', NB, TOTAL, false);
  return true;
 }

 // Peut-on raliser TOTAL = NB * ?
 if (TOTAL%NB == 0)
 {
  trouv = lcb(tr, TOTAL/NB, Niv+1);
  if (trouv)
  {
   RetenirOpration(Niv, NB, '*', (TOTAL/NB), TOTAL, false);
   return true;
  }
 }

 // Peut-on raliser TOTAL = NB / ?
 if (NB%TOTAL == 0)
 {
  trouv = lcb(tr, NB/TOTAL, Niv+1);
  if (trouv)
  {
   RetenirOpration(Niv, NB, '/', (NB/TOTAL), TOTAL, false);
   return true;
  }
 }
 return false;
}


//
// --- fonction lcb ----------------------------------------------------
//
  static bool lcb(int[] N, int TOTAL, int Niv)
  {
   bool trouv;
   int[] tr;

   if (TOTAL<=0 || N.Length==0) 
   {
//    Console.WriteLine("Dans lcb avec TOTAL < 0");
    return false;
   }


   // trier le tableau des nombres restants par ordre dcroissant
   Array.Sort(N); Array.Reverse(N);


   // Un seul des nombres restants ferait-il l'affaire ?
   for (int i=0; i<N.Length; i++)
    if (N[i] == TOTAL) return true;

   // s'il ne reste plus que deux nombres ....
   if (N.Length == 2) return TrouverDansDeux(TOTAL, N[0], N[1], Niv);


   // --------------------------------------------------------------------------------------
   //
   // prendre l'un des nombres restants et essayer une combinaison  partir de ce nombre
   for (int i=0; i<N.Length; i++)
   {  
    // Prparer le tableau tr des nombres restants
    tr = new int[N.Length-1];
    for (int j=0, k=0; j<N.Length; j++)
     if (i != j) {tr[k] = N[j]; k++;}

    // Essayer une combinaison TOTAL = N[i] op ?
    // (op dsigne une opration arithmtique et ? une combinaison des nombres restants
    // (nombres faisant partie de tr)
    trouv = EssaiOpration(TOTAL, N[i], tr, Niv);
    if (trouv == true) return true;
   }

   // --------------------------------------------------------------------------------------
   //
   // essayer ensuite une opration  partir de deux nombres

   if (N.Length < 3) 
   {
    Console.WriteLine("Ici avec un tableau de moins de 3 lments !!");
    return false;
   }

   for (int i=0; i<N.Length; i++)                      // choix du premier nombre
   {
    // prendre un deuxime nombre parmi les restants
    for (int j=i+1; j<N.Length; j++)                   // choix du deuxime nombre
    {
     tr = new int[N.Length-2];
     int n=0;
     for (int k=0; k<N.Length; k++)
      if (k!=i && k!=j) {tr[n] = N[k]; n++;}
    
     // essayer l'addition de ces deux nombres   
     // ajouter la somme au tableau des nombres restants
     int[] tr2 = new int[tr.Length+1];
     for (int k=0; k<tr.Length; k++) tr2[k] = tr[k]; tr2[tr.Length] = N[i] + N[j];
     Array.Sort(tr2); Array.Reverse(tr2);
     trouv = lcb(tr2, TOTAL, Niv+1);
     if (trouv == true) 
     {
      RetenirOpration(Niv, N[i], '+', N[j], N[i]+N[j], true);
      return true;
     }

    // essayer la soustraction de ces deux nombres    
    // ajouter la diffrence au tableau des nombres restants
    tr2 = new int[tr.Length+1];
    for (int k=0; k<tr.Length; k++) tr2[k] = tr[k]; tr2[tr.Length] = N[i] - N[j];
    Array.Sort(tr2); Array.Reverse(tr2);
     if (N[i] != N[j])
     {
      trouv = lcb(tr2, TOTAL, Niv+1);
      if (trouv == true) 
      {
       RetenirOpration(Niv, N[i], '-', N[j], N[i]-N[j], true);       
       return true;
      }
     }

     // essayer la multiplication de ces deux nombres    
     // ajouter le produit au tableau des nombres restants
     tr2 = new int[tr.Length+1];
     for (int k=0; k<tr.Length; k++) tr2[k] = tr[k]; tr2[tr.Length] = N[i] * N[j];
     Array.Sort(tr2); Array.Reverse(tr2);
     trouv = lcb(tr2, TOTAL, Niv+1);
     if (trouv == true) 
     {
      RetenirOpration(Niv, N[i], '*', N[j], N[i]*N[j], true);       
      return true;
     }

    // essayer la division de ces deux nombres  
    if (N[i]%N[j] == 0)
    {
     tr2 = new int[tr.Length+1];
     for (int k=0; k<tr.Length; k++) tr2[k] = tr[k]; tr2[tr.Length] = N[i] / N[j];
     Array.Sort(tr2); Array.Reverse(tr2);
     trouv = lcb(tr2, TOTAL, Niv+1);
     if (trouv == true) 
     {
      RetenirOpration(Niv, N[i], '/', N[j], N[i]/N[j], true);       
      return true;
     }
    }

    }
   }

   return false;
  }


//
// --------------------------------------------------------------------------
//
 static bool TrouverDansDeux(int TOTAL, int N1, int N2, int Niv)
 {

  if (TOTAL == N1+N2)
  {
   RetenirOpration(Niv, N1, '+', N2, TOTAL, false);
   return true;
  }

  if (TOTAL == N1-N2)
  {
   RetenirOpration(Niv, N1, '-', N2, TOTAL, false);
   return true;
  }

  if (TOTAL == N2-N1)
  {
   RetenirOpration(Niv, N2, '-', N1, TOTAL, false);
   return true;
  }

  if (TOTAL == N1*N2)
  {
   RetenirOpration(Niv, N1, '*', N2, TOTAL, false);
   return true;
  }

  if (N1>N2 && N1%N2==0 && TOTAL==N1/N2)
  {
   RetenirOpration(Niv, N1, '/', N2, TOTAL, false);
   return true;
  }

  if (N2>N1 && N2%N1==0 && TOTAL==N2/N1)
  {
   RetenirOpration(Niv, N2, '/', N1, TOTAL, false);
   return true;
  }

  return false;
  }           // fin de la fonction TrouverDansDeux
 }            // fin de la classe LeCompteEstBon
}            // fin de l'espace de noms